// Note: Current version of DLL is using outp() calls which are not allowed under WinXP and later
// Therefore must run as Windows98 compatible application. 
// You are free to rewrite it....

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>

#define WDT_SYSTEMRESET	0xD0  // bit mask for Reset system


typedef int (*pSetWDT)(unsigned int nTime, unsigned char nEvent);
typedef void(*pResetWDT)(void);
typedef void(*pDisableWDT)(void);

HINSTANCE		hDLL;
pSetWDT			SetWDT[2];
pResetWDT		ResetWDT[2];
pDisableWDT		DisableWDT[2];


int _tmain(int argc, _TCHAR* argv[])
{
unsigned int  iTime;
unsigned int  loopactive;
long lTime;
long rTime;

loopactive=0;
lTime=5; // default value 5s
rTime=3; // default value 3s

	if(argc < 3)
	{
		printf("Usage: %s <W?> <T?/D/R>\n\n", argv[0]);
		printf("W Watch Dog Timer select -> 0 ~ 1\n");
		printf("T Time till reboot system if not WDT reset is done -> 1 ~ 512(s)\n");
		printf("R Reset of WDT counter");
		printf("L Will do self loop check endless. Loop time -> 1 ~ 512(s)\n");
		printf("\n");
		printf("Ex: %s W0 T5   -> Set WDT0 = 5s and enable it\n", argv[0]);
		printf("    %s W1 D    -> Disable WDT1\n", argv[0]);
		printf("    %s W0 R    -> Reset WDT0\n", argv[0]);
		printf("    %s W0 T10 L6   -> Set WDT0 = 10s and reset them in loop each 6s\n", argv[0]);
		printf("\n\nNote: Windows XP and later must setup run application as Windows 98 Compatible!");
		return 1;
	}

	hDLL = LoadLibrary(_T("WDT.dll"));    //load dll file
	if (hDLL == NULL)
	{
		printf("Not find file: WDT.dll\r\n");	
		return 1;
	}

	SetWDT[0]      = (pSetWDT) GetProcAddress(hDLL, _T("SetWDT0"));
	SetWDT[1]      = (pSetWDT)		GetProcAddress(hDLL, _T("SetWDT1"));
	ResetWDT[0]    = (pResetWDT)	GetProcAddress(hDLL, _T("ResetWDT0"));
	ResetWDT[1]    = (pResetWDT)	GetProcAddress(hDLL, _T("ResetWDT1"));
	DisableWDT[0]  = (pDisableWDT)	GetProcAddress(hDLL, _T("DisableWDT0"));
	DisableWDT[1]  = (pDisableWDT)	GetProcAddress(hDLL, _T("DisableWDT1"));
	
	BYTE nWatchDog=0x80;
	for(int i = 1; i < argc; i++)
	{
		if(argv[i][0]=='W' || argv[i][0]=='w')
		{
			nWatchDog=argv[i][1]-'0';
			if(nWatchDog>1 || nWatchDog<0)
			{
				printf("Watch dog number parameter error!\n");
				return 1;
			}
		}
	}
	
	if(nWatchDog==0x80)
	{
		printf("Parameter error!\r\n");
		return 1;
	}

	for(int i = 1; i < argc; i++)
	{
		if(argv[i][0]=='R' || argv[i][0]=='r')
		{
			ResetWDT[nWatchDog]();
			printf("WDT%d has already been reseted!\r\n",nWatchDog);
			break;
		}
		else if(argv[i][0]=='D' || argv[i][0]=='d')
		{
			DisableWDT[nWatchDog]();
			printf("WDT%d has already been disabled!\r\n",nWatchDog);
			break;
		}
		else if(argv[i][0]=='T' || argv[i][0]=='t')
		{
			// long lTime=_wtol(argv[i]+1);
			lTime=atol(argv[i]+1);
			if(lTime>512 || lTime<=0)
			{
				printf("Time Parameter error!\r\n");
				return 1;
			}
			else
			{	
				iTime=1000L*lTime;
				SetWDT[nWatchDog](iTime,WDT_SYSTEMRESET);
				printf("System will be reset after %ld seconds.\n", lTime);
				// break;
			}
		}
		else if(argv[i][0]=='L' || argv[i][0]=='l')
		{ 
			loopactive=1;
			long rTime=atol(argv[i]+1);
			// break;
		};
	}	

	
	if(loopactive)
	{
			if ( rTime>=lTime )
			{
				printf("Time Parameter error: time for loop reset must be smaller then timer time!\r\n");
				return 1;
			}

			printf("Entering endless loop: Timer for reboot %ld seconds. Refresh each %ld seconds.\r\n",lTime, rTime);
		do {
			Sleep(rTime*1000);
			// Here printing or other actions to let check system is alive
			// printf("Refreshing watchdog...\n");
			ResetWDT[nWatchDog]();
		} while (1);
	}

	return 0;
}

